//
//  XHLWaterViewController.m
//  TestCollectionLayout
//
//  Created by xhl on 16/6/15.
//  Copyright © 2016年 xhl. All rights reserved.
//

#import "XHLWaterViewController.h"
#import "XHLWaterLayout.h"

@interface XHLWaterViewController ()<UICollectionViewDataSource,XHLWaterLayoutDelegate,UICollectionViewDelegate>

@end

@implementation XHLWaterViewController


static NSString * XHLCellId = @"cellId";

- (void)viewDidLoad {
    [super viewDidLoad];
    
    // 创建布局
    XHLWaterLayout *layout = [[XHLWaterLayout alloc] init];
    layout.delegate = self;
    // 创建CollectionView
    UICollectionView *collectionView = [[UICollectionView alloc] initWithFrame:self.view.bounds collectionViewLayout:layout];
    collectionView.dataSource = self;
    collectionView.delegate   = self;
    collectionView.showsVerticalScrollIndicator = NO;
    collectionView.backgroundColor = [UIColor whiteColor];
    [self.view addSubview:collectionView];
    
    // 注册
    [collectionView registerClass:[UICollectionViewCell class] forCellWithReuseIdentifier:XHLCellId];
}

- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section
{
    
    return 100;
}


- (UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath
{
    UICollectionViewCell * cell = [collectionView dequeueReusableCellWithReuseIdentifier:XHLCellId forIndexPath:indexPath];
    cell.backgroundColor = [UIColor yellowColor];
    NSInteger tag = 10;
    UILabel *label = (UILabel *)[cell.contentView viewWithTag:tag];
    if (label == nil) {
        label = [[UILabel alloc] init];
        label.tag = tag;
        label.font = [UIFont systemFontOfSize:15];
        [cell.contentView addSubview:label];
    }
    
    label.text = [NSString stringWithFormat:@"第%@个item",@(indexPath.row)];
    [label sizeToFit];
    
    return cell;
}

- (CGFloat)waterLayout:(UICollectionViewLayout *)waterLayout itemWidth:(CGFloat)itemWidth indexPath:(NSIndexPath *)indexPath
{
    return 40 + arc4random_uniform(100);
}

- (NSInteger)numberOfSectionsInCollectionView:(UICollectionView *)collectionView
{
    return 2;
}


- (UIEdgeInsets)edgeInsetsInWaterflowLayout:(UICollectionViewLayout*)layout
{
    return UIEdgeInsetsMake(10, 10, 10, 10);
}

- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath
{
    NSLog(@"点击了第%@item",@(indexPath.row));
}


@end
